Index: gnu/usr.bin/perl/pod/perldelta.pod
===================================================================
RCS file: /usr/obj/OP/cvs/src/gnu/usr.bin/perl/pod/perldelta.pod,v
retrieving revision 1.24
diff -u -p -a -u -p -r1.24 perldelta.pod
--- gnu/usr.bin/perl/pod/perldelta.pod	15 Feb 2023 01:36:35 -0000	1.24
+++ gnu/usr.bin/perl/pod/perldelta.pod	21 May 2023 00:39:36 -0000
@@ -1039,359 +36,21 @@ have now I<also> been removed from the d
 
 =item *
 
-The Perl C source code now uses some C99 features, which we have verified are
-supported by all compilers we target. This means that Perl's headers now
-contain some code that is legal in C99 but not C89.
-
-This may cause problems for some XS modules that unconditionally add
-C<-Werror=declaration-after-statement> to their C compiler flags if compiling
-with gcc or clang. Earlier versions of Perl support long obsolete compilers
-that are strict in rejecting certain C99 features, particularly mixed
-declarations and code, and hence it makes sense for XS module authors to audit
-that their code does not violate this. However, doing this is now only
-possible on these earlier versions of Perl, hence these modules need to be
-changed to only add this flag for C<<$] < 5.035005>>.
-
-=item *
-
-The makedepend step is now run in parallel by using make
-
-When using MAKEFLAGS=-j8, this significantly reduces the time required for:
-
-    sh ./makedepend MAKE=make cflags
-
-=item *
-
-F<Configure> now tests whether C<< #include <xlocale.h> >> is required
-to use the POSIX 1003 thread-safe locale functions or some related
-extensions.  This prevents problems where a non-public F<xlocale.h> is
-removed in a library update, or F<xlocale.h> isn't intended for public
-use. (github L<#18936|https://github.com/Perl/perl5/pull/18936>)
+C<Configure> probed for the return type of malloc() and free() by testing
+whether declarations for those functions produced a function type mismatch with
+the implementation.  On Solaris, with a C++ compiler, this check always failed,
+since Solaris instead imports malloc() and free() from C<std::> with C<using>
+for C++ builds.  Since the return types of malloc() and free() are well defined
+by the C standard, skip probing for them.  C<Configure> command-line arguments
+and hints can still override these type in the unlikely case that is needed.
+[L<GH #20806|https://github.com/Perl/perl5/issues/20806>]
 
 =back
 
 =head1 Testing
 
-Tests were added and changed to reflect the other additions and changes
-in this release.
-
-=head1 Platform Support
-
-=head2 Windows
-
-=over 4
-
-=item *
-
-Support for old MSVC++ (pre-VC12) has been removed
-
-These did not support C99 and hence can no longer be used to compile perl.
-
-=item *
-
-Support for compiling perl on Windows using Microsoft Visual Studio 2022
-(containing Visual C++ 14.3) has been added.
-
-=item *
-
-The :win32 IO layer has been removed. This experimental replacement for the
-:unix layer never reached maturity in its nearly two decades of existence.
-
-=back
-
-=head2 VMS
-
-=over 4
-
-=item C<keys %ENV> on VMS returns consistent results
-
-On VMS entries in the C<%ENV> hash are loaded from the OS environment on
-first access, hence the first iteration of C<%ENV> requires the entire
-environment to be scanned to find all possible keys. This initialisation had
-always been done correctly for full iteration, but previously was not
-happening for C<%ENV> in scalar context, meaning that C<scalar %ENV> would
-return 0 if called before any other C<%ENV> access, or would only return the
-count of keys accessed if there had been no iteration.
-
-These bugs are now fixed - C<%ENV> and C<keys %ENV> in scalar context now
-return the correct result - the count of all keys in the environment.
-
-=back
-
-=head2 Discontinued Platforms
-
-=over 4
-
-=item AT&T UWIN
-
-UWIN is a UNIX compatibility layer for Windows.  It was last released
-in 2012 and has been superseded by Cygwin these days.
-
-=item DOS/DJGPP
-
-DJGPP is a port of the GNU toolchain to 32-bit x86 systems running
-DOS.  The last known attempt to build Perl on it was on 5.20, which
-only got as far as building miniperl.
-
-=item NetWare
-
-Support code for Novell NetWare has been removed.  NetWare was a
-server operating system by Novell.  The port was last updated in July
-2002, and the platform itself in May 2009.
-
-Unrelated changes accidentally broke the build for the NetWare port in
-September 2009, and in 12 years no-one has reported this.
-
-=back
-
-=head2 Platform-Specific Notes
-
-=over 4
-
-=item z/OS
-
-This update enables us to build EBCDIC static/dynamic and 31-bit/64-bit
-addressing mode Perl. The number of tests that pass is consistent with the
-baseline before these updates.
-
-These changes also provide the base support to be able to provide ASCII
-static/dynamic and 31-bit/64-bit addressing mode Perl.
-
-The z/OS (previously called OS/390) README was updated to describe ASCII and
-EBCDIC builds.
-
-=back
-
-=head1 Internal Changes
-
-=over 4
-
-=item *
-
-Since the removal of PERL_OBJECT in Perl 5.8, PERL_IMPLICIT_CONTEXT and
-MULTIPLICITY have been synonymous and they were being used interchangeably.
-To simplify the code, all instances of PERL_IMPLICIT_CONTEXT have been
-replaced with MULTIPLICITY.
-
-PERL_IMPLICIT_CONTEXT will remain defined for compatibility with XS modules.
-
-=item *
-
-The API constant formerly named C<G_ARRAY>, indicating list context, has now
-been renamed to a more accurate C<G_LIST>.  A compatibilty macro C<G_ARRAY> has
-been added to allow existing code to work unaffected.  New code should be
-written using the new constant instead.  This is supported by C<Devel::PPPort>
-version 3.63.
-
-=item *
-
-Macros have been added to F<perl.h> to facilitate version comparisons:
-C<PERL_GCC_VERSION_GE>, C<PERL_GCC_VERSION_GT>, C<PERL_GCC_VERSION_LE> and
-C<PERL_GCC_VERSION_LT>.
-
-Inline functions have been added to F<embed.h> to determine the position of
-the least significant 1 bit in a word: C<lsbit_pos32> and C<lsbit_pos64>.
-
-=item *
-
-C<Perl_ptr_table_clear> has been deleted. This has been marked as deprecated
-since v5.14.0 (released in 2011), and is not used by any code on CPAN.
-
-=item *
-
-Added new boolean macros and functions. See L</Stable boolean tracking> for
-related information and L<perlapi> for documentation.
-
-=over 4
-
-=item *
-
-sv_setbool
-
-=item *
-
-sv_setbool_mg
-
-=item *
-
-SvIsBOOL
-
-=back
-
-=item *
-
-Added 4 missing functions for dealing with RVs:
-
-=over 4
-
-=item *
-
-sv_setrv_noinc
-
-=item *
-
-sv_setrv_noinc_mg
-
-=item *
-
-sv_setrv_inc
-
-=item *
-
-sv_setrv_inc_mg
-
-=back
-
-=item *
-
-C<xs_handshake()>'s two failure modes now provide distinct messages.
-
-=item *
-
-Memory for hash iterator state (C<struct xpvhv_aux>) is now allocated as part
-of the hash body, instead of as part of the block of memory allocated for the
-main hash array.
-
-=item *
-
-A new phase_name() interface provides access to the name for each interpreter
-phase (i.e., PL_phase value).
-
-=item *
-
-The C<pack> behavior of C<U> has changed for EBCDIC.
-
-=item *
-
-New equality-test functions C<sv_numeq> and C<sv_streq> have been added, along
-with C<..._flags>-suffixed variants.  These expose a simple and consistent API
-to perform numerical or string comparison which is aware of operator
-overloading.
-
-=item *
-
-Reading the string form of an integer value no longer sets the flag C<SVf_POK>.
-The string form is still cached internally, and still re-read directly by the
-macros C<SvPV(sv)> I<etc> (inline, without calling a C function). XS code that
-already calls the APIs to get values will not be affected by this change. XS
-code that accesses flags directly instead of using API calls to express its
-intent I<might> break, but such code likely is already buggy if passed some
-other values, such as floating point values or objects with string overloading.
-
-This small change permits code (such as JSON serializers) to reliably determine
-between
-
-=over 4
-
-=item *
-
-a value that was initially B<written> as an integer, but then B<read> as a string
-
-    my $answer = 42;
-    print "The answer is $answer\n";
-
-=item *
-
-that same value that was initially B<written> as a string, but then B<read> as an integer
-
-    my $answer = "42";
-    print "That doesn't look right\n"
-        unless $answer == 6 * 9;
-
-=back
-
-For the first case (originally written as an integer), we now have:
-
-    use Devel::Peek;
-    my $answer = 42;
-    Dump ($answer);
-    my $void = "$answer";
-    print STDERR "\n";
-    Dump($answer)
-
-
-    SV = IV(0x562538925778) at 0x562538925788
-      REFCNT = 1
-      FLAGS = (IOK,pIOK)
-      IV = 42
-
-    SV = PVIV(0x5625389263c0) at 0x562538925788
-      REFCNT = 1
-      FLAGS = (IOK,pIOK,pPOK)
-      IV = 42
-      PV = 0x562538919b50 "42"\0
-      CUR = 2
-      LEN = 10
-
-For the second (originally written as a string), we now have:
-
-    use Devel::Peek;
-    my $answer = "42";
-    Dump ($answer);
-    my $void = $answer == 6 * 9;
-    print STDERR "\n";
-    Dump($answer)'
-
-
-    SV = PV(0x5586ffe9bfb0) at 0x5586ffec0788
-      REFCNT = 1
-      FLAGS = (POK,IsCOW,pPOK)
-      PV = 0x5586ffee7fd0 "42"\0
-      CUR = 2
-      LEN = 10
-      COW_REFCNT = 1
-
-    SV = PVIV(0x5586ffec13c0) at 0x5586ffec0788
-      REFCNT = 1
-      FLAGS = (IOK,POK,IsCOW,pIOK,pPOK)
-      IV = 42
-      PV = 0x5586ffee7fd0 "42"\0
-      CUR = 2
-      LEN = 10
-      COW_REFCNT = 1
-
-(One can't rely on the presence or absence of the flag C<SVf_IsCOW> to
-determine the history of operations on a scalar.)
-
-Previously both cases would be indistinguishable, with all 4 flags set:
-
-    SV = PVIV(0x55d4d62edaf0) at 0x55d4d62f0930
-      REFCNT = 1
-      FLAGS = (IOK,POK,pIOK,pPOK)
-      IV = 42
-      PV = 0x55d4d62e1740 "42"\0
-      CUR = 2
-      LEN = 10
-
-(and possibly C<SVf_IsCOW>, but not always)
-
-This now means that if XS code I<really> needs to determine which form a value
-was first written as, it should implement logic roughly
-
-    if (flags & SVf_IOK|SVf_NOK) && !(flags & SVf_POK)
-        serialize as number
-    else if (flags & SVf_POK)
-        serialize as string
-    else
-        the existing guesswork ...
-
-Note that this doesn't cover "dualvars" - scalars that report different
-values when asked for their string form or number form (such as C<$!>).
-Most serialization formats cannot represent such duplicity.
-
-I<The existing guesswork> remains because as well as dualvars, values might
-be C<undef>, references, overloaded references, typeglobs and other things that
-Perl itself can represent but do not map one-to-one into external formats, so
-need some amount of approximation or encapsulation.
-
-=item *
-
-C<sv_dump> (and L<Devel::Peek>’s C<Dump> function) now escapes high-bit
-octets in the PV as hex rather than octal. Since most folks understand hex
-more readily than octal, this should make these dumps a bit more legible.
-This does B<not> affect any other diagnostic interfaces like C<pv_display>.
-
-=back
+Tests were added and changed to reflect the other additions and changes in this
+release.
 
 =head1 Selected Bug Fixes
 
@@ -1399,159 +58,63 @@ This does B<not> affect any other diagno
 
 =item *
 
-utime() now correctly sets errno/C<$!> when called on a closed handle.
-
-=item *
-
-The flags on the OPTVAL parameter to setsockopt() were previously
-checked before magic was called, possibly treating a numeric value as
-a packed buffer or vice versa.  It also ignored the UTF-8 flag,
-potentially treating the internal representation of an upgraded SV as
-the bytes to supply to the setsockopt() system call.  (github L<#18660|https://github.com/Perl/perl5/issues/18660>)
-
-=item *
-
-Only set IOKp, not IOK on $) and $(.
-This was issue L<#18955|https://github.com/Perl/perl5/issues/18955>: This will prevent serializers from serializing these
-variables as numbers (which loses the additional groups).
-This restores behaviour from 5.16
-
-=item *
-
-Use of the C<mktables> debugging facility would cause perl to croak since
-v5.31.10; this problem has now been fixed.
-
-=item *
-
-C<makedepend> logic is now compatible with BSD make (fixes
-L<GH #19046|https://github.com/Perl/perl5/issues/19046>).
-
-=item *
-
-Calling C<untie> on a tied hash that is partway through iteration now frees the
-iteration state immediately.
-
-Iterating a tied hash causes perl to store a copy of the current hash key to
-track the iteration state, with this stored copy passed as the second parameter
-to C<NEXTKEY>. This internal state is freed immediately when tie hash iteration
-completes, or if the hash is destroyed, but due to an implementation oversight,
-it was not freed if the hash was untied. In that case, the internal copy of the
-key would persist until the earliest of
-
-=over 4
-
-=item 1
-
-C<tie> was called again on the same hash
-
-=item 2
-
-The (now untied) hash was iterated (ie passed to any of C<keys>, C<values> or
-C<each>)
-
-=item 3
-
-The hash was destroyed.
-
-=back
-
-This inconsistency is now fixed - the internal state is now freed immediately by
-C<untie>.
-
-As the precise timing of this behaviour can be observed with pure Perl code
-(the timing of C<DESTROY> on objects returned from C<FIRSTKEY> and C<NEXTKEY>)
-it's just possible that some code is sensitive to it.
-
-=item *
-
-The C<Internals::getcwd()> function added for bootstrapping miniperl
-in perl 5.30.0 is now only available in miniperl. [github #19122]
+An eval() as the last statement in a regex code block could trigger an
+interpreter panic; e.g.
 
-=item *
+    /(?{ ...; eval {....}; })/
 
-Setting a breakpoint on a BEGIN or equivalently a C<use> statement
-could cause a memory write to a freed C<dbstate> op.
-[L<GH #19198|https://github.com/Perl/perl5/issues/19198>]
+[L<GH #19680|https://github.com/Perl/perl5/issues/19680>]
 
 =item *
 
-When bareword filehandles are disabled, the parser was interpreting
-any bareword as a filehandle, even when immediatey followed by parens.
-
-=back
-
-=head1 Errata From Previous Releases
-
-=over 4
+An C<eval EXPR> referring to a lexical sub defined in grandparent scope no
+longer produces an assertion failures.
+[L<GH #19857|https://github.com/Perl/perl5/issues/19857>]
 
 =item *
 
-L<perl5300delta> mistakenly identified a CVE whose correct identification is
-CVE-2015-1592.
+Writing to a magic variables associated with the selected output handle, C<$^>,
+C<$~>, C<$=>, C<$-> and C<$%>, no longer crashes perl if the IO object has been
+cleared from the selected output handle.
+[L<GH #20733|https://github.com/Perl/perl5/issues/20733>]
 
 =back
 
-=head1 Obituaries
-
-Raun "Spider" Boardman (SPIDB on CPAN), author of at least 66 commits to the
-Perl 5 core distribution between 1996 and 2002, passed away May 24, 2021 from
-complications of COVID.  He will be missed.
-
-David H. Adler (DHA) passed away on November 16, 2021.  In 1997, David
-co-founded NY.pm, the first Perl user group, and in 1998 co-founded Perl
-Mongers to help establish other user groups across the globe.  He was a
-frequent attendee at Perl conferences in both North America and Europe and well
-known for his role in organizing I<Bad Movie Night> celebrations at those
-conferences.  He also contributed to the work of the Perl Foundation, including
-administering the White Camel awards for community service.  He will be missed.
-
 =head1 Acknowledgements
 
-Perl 5.36.0 represents approximately a year of development since Perl
-5.34.0 and contains approximately 250,000 lines of changes across 2,000
-files from 82 authors.
+Perl 5.36.1 represents approximately 11 months of development since Perl 5.36.0
+and contains approximately 5,500 lines of changes across 62 files from 24
+authors.
 
 Excluding auto-generated files, documentation and release tools, there were
-approximately 190,000 lines of changes to 1,300 .pm, .t, .c and .h files.
+approximately 1,600 lines of changes to 23 .pm, .t, .c and .h files.
 
-Perl continues to flourish into its fourth decade thanks to a vibrant
-community of users and developers. The following people are known to have
-contributed the improvements that became Perl 5.36.0:
-
-Alyssa Ross, Andrew Fresh, Aristotle Pagaltzis, Asher Mancinelli, Atsushi
-Sugawara, Ben Cornett, Bernd, Biswapriyo Nath, Brad Barden, Bram, Branislav
-Zahradník, brian d foy, Chad Granum, Chris 'BinGOs' Williams, Christian
-Walde (Mithaldu), Christopher Yeleighton, Craig A. Berry, cuishuang, Curtis
-Poe, Dagfinn Ilmari Mannsåker, Dan Book, Daniel Laügt, Dan Jacobson, Dan
-Kogai, Dave Cross, Dave Lambley, David Cantrell, David Golden, David
-Marshall, David Mitchell, E. Choroba, Eugen Konkov, Felipe Gasper, François
-Perrad, Graham Knop, H.Merijn Brand, Hugo van der Sanden, Ilya Sashcheka,
-Ivan Panchenko, Jakub Wilk, James E Keenan, James Raspass, Karen Etheridge,
-Karl Williamson, Leam Hall, Leon Timmermans, Magnus Woldrich, Matthew
-Horsfall, Max Maischein, Michael G Schwern, Michiel Beijen, Mike Fulton,
-Neil Bowers, Nicholas Clark, Nicolas R, Niyas Sait, Olaf Alders, Paul Evans,
-Paul Marquess, Petar-Kaleychev, Pete Houston, Renee Baecker, Ricardo Signes,
-Richard Leach, Robert Rothenberg, Sawyer X, Scott Baker, Sergey Poznyakoff,
-Sergey Zhmylove, Sisyphus, Slaven Rezic, Steve Hay, Sven Kirmess, TAKAI
-Kousuke, Thibault Duponchelle, Todd Rinaldo, Tomasz Konojacki, Tomoyuki
-Sadahiro, Tony Cook, Unicode Consortium, Yves Orton, Михаил
-Козачков.
-
-The list above is almost certainly incomplete as it is automatically
-generated from version control history. In particular, it does not include
-the names of the (very much appreciated) contributors who reported issues to
-the Perl bug tracker.
+Perl continues to flourish into its fourth decade thanks to a vibrant community
+of users and developers.  The following people are known to have contributed
+the improvements that became Perl 5.36.1:
+
+Andreas König, Bram, Chris 'BinGOs' Williams, Craig A. Berry, Dagfinn Ilmari
+Mannsåker, David Mitchell, Elvin Aslanov, Florian Weimer, Graham Knop, Hugo
+van der Sanden, Karen Etheridge, Karl Williamson, Leon Timmermans, Matthew
+Horsfall, Max Maischein, Neil Bowers, Nicolas R, Renee Baecker, Ricardo Signes,
+Richard Leach, Steve Hay, Todd Rinaldo, Tony Cook, Yves Orton.
+
+The list above is almost certainly incomplete as it is automatically generated
+from version control history.  In particular, it does not include the names of
+the (very much appreciated) contributors who reported issues to the Perl bug
+tracker.
 
 Many of the changes included in this version originated in the CPAN modules
-included in Perl's core. We're grateful to the entire CPAN community for
+included in Perl's core.  We're grateful to the entire CPAN community for
 helping Perl to flourish.
 
-For a more complete list of all of Perl's historical contributors, please
+For a more complete list of all of Perl's historical contributors, please see
+the F<AUTHORS> file in the Perl source distribution.
 
 =head1 Reporting Bugs
 
-If you find what you think is a bug, you might check the perl bug database
-at L<https://github.com/Perl/perl5/issues>.  There may also be information at
+If you find what you think is a bug, you might check the perl bug database at
+L<https://github.com/Perl/perl5/issues>.  There may also be information at
 L<http://www.perl.org/>, the Perl Home Page.
 
 If you believe you have an unreported bug, please open an issue at
@@ -1560,13 +123,13 @@ tiny but sufficient test case.
 
 If the bug you are reporting has security implications which make it
 inappropriate to send to a public issue tracker, then see
-L<perlsec/SECURITY VULNERABILITY CONTACT INFORMATION>
-for details of how to report the issue.
+L<perlsec/SECURITY VULNERABILITY CONTACT INFORMATION> for details of how to
+report the issue.
 
 =head1 Give Thanks
 
-If you wish to thank the Perl 5 Porters for the work we had done in Perl 5,
-you can do so by running the C<perlthanks> program:
+If you wish to thank the Perl 5 Porters for the work we had done in Perl 5, you
+can do so by running the C<perlthanks> program:
 
     perlthanks
 
Index: gnu/usr.bin/perl/pod/perlexperiment.pod
===================================================================
RCS file: /usr/obj/OP/cvs/src/gnu/usr.bin/perl/pod/perlexperiment.pod,v
retrieving revision 1.6
diff -u -p -a -u -p -r1.6 perlexperiment.pod
--- gnu/usr.bin/perl/pod/perlexperiment.pod	15 Feb 2023 01:36:35 -0000	1.6
+++ gnu/usr.bin/perl/pod/perlexperiment.pod	21 May 2023 00:39:36 -0000
@@ -184,7 +184,7 @@ L<[perl #19764]|https://github.com/Perl/
 
 Introduced in Perl 5.36.0
 
-Using this feature triggers warnings in the category C<builtin::defer>.
+Using this feature triggers warnings in the category C<experimental::defer>.
 
 This feature adds a new kind of block, a C<defer> block, which will not be
 executed until the containing block is being exited.
@@ -197,7 +197,7 @@ L<[perl #17949]|https://github.com/Perl/
 Introduced in Perl 5.36.0
 
 Using this feature triggers warnings in the category
-C<builtin::extra_paired_delimiters>.
+C<experimental::extra_paired_delimiters>.
 
 This feature allows for many non-ASCII pairs of mirroring delimiters, for
 example:
Index: gnu/usr.bin/perl/pod/perlhist.pod
===================================================================
RCS file: /usr/obj/OP/cvs/src/gnu/usr.bin/perl/pod/perlhist.pod,v
retrieving revision 1.28
diff -u -p -a -u -p -r1.28 perlhist.pod
--- gnu/usr.bin/perl/pod/perlhist.pod	15 Feb 2023 01:36:35 -0000	1.28
+++ gnu/usr.bin/perl/pod/perlhist.pod	21 May 2023 00:39:36 -0000
@@ -35,7 +35,7 @@ Little, Dave Rolsky, Max Maischein, Abig
 Dominic Hargreaves, Aaron Crane, Aristotle Pagaltzis, Matthew Horsfall,
 Peter Martini, Sawyer X, Chad 'Exodist' Granum, Renee Bäcker, Eric Herman,
 John SJ Anderson, Karen Etheridge, Zak B. Elep, Tom Hukins, Richard Leach,
-and Neil Bowers.
+Neil Bowers and Yves Orton.
 
 =head2 PUMPKIN?
 
@@ -734,6 +734,23 @@ the strings?).
  Ricardo   5.36.0-RC2   2022-May-20
  Ricardo   5.36.0-RC3   2022-May-22
  Ricardo   5.36.0       2022-May-27
+ Steve     5.36.1-RC1   2023-Apr-10
+ Steve     5.36.1-RC2   2023-Apr-11
+ Steve     5.36.1-RC3   2023-Apr-16
+ Steve     5.36.1       2023-Apr-23
+
+ Ricardo   5.37.0       2022-May-27     The 5.37 development track
+ Matthew H 5.37.1       2022-Jun-20
+ Nicolas R 5.37.2       2022-Jul-20
+ Neil B    5.37.3       2022-Aug-20
+ Ether     5.37.4       2022-Sep-20
+ Todd R    5.37.5       2022-Oct-20
+ Max M     5.37.6       2022-Nov-20
+ Richard L 5.37.7       2022-Dec-20
+ Renee     5.37.8       2023-Jan-20
+ Ether     5.37.9       2023-Feb-20
+ Yves      5.37.10      2023-Mar-20
+ Steve     5.37.11      2023-Apr-20
 
 =head2 SELECTED RELEASE SIZES
 
Index: gnu/usr.bin/perl/t/io/defout.t
===================================================================
RCS file: /usr/obj/OP/cvs/src/gnu/usr.bin/perl/t/io/defout.t,v
retrieving revision 1.4
diff -u -p -a -u -p -r1.4 defout.t
--- gnu/usr.bin/perl/t/io/defout.t	30 Dec 2019 02:13:56 -0000	1.4
+++ gnu/usr.bin/perl/t/io/defout.t	21 May 2023 00:39:36 -0000
@@ -14,7 +14,7 @@ BEGIN {
 
 $|=0;   # test.pl makes it 1, and that conflicts with the below.
 
-plan tests => 16;
+plan tests => 22;
 
 
 my $stdout = *STDOUT;
@@ -47,6 +47,20 @@ $= = 1; pass '$= = 1';
 $- = 1; pass '$- = 1';
 $% = 1; pass '$% = 1';
 $| = 1; pass '$| = 1';
+
+# test a NULLed GV
+my $t = tempfile;
+open FOO, ">", $t or die;
+select(FOO);
+my $io = *FOO{IO};
+*FOO = 0;
+$^ = 1; pass 'empty GV: $^ = 1';
+$~ = 1; pass 'empty GV: $~ = 1';
+$= = 1; pass 'empty GV: $= = 1';
+$- = 1; pass 'empty GV: $- = 1';
+$% = 1; pass 'empty GV: $% = 1';
+$| = 1; pass 'empty GV: $| = 1';
+close $io;
 
 # Switch to STDERR for this test, so we do not lose our test output
 my $stderr = *STDERR;
Index: gnu/usr.bin/perl/t/op/lexsub.t
===================================================================
RCS file: /usr/obj/OP/cvs/src/gnu/usr.bin/perl/t/op/lexsub.t,v
retrieving revision 1.3
diff -u -p -a -u -p -r1.3 lexsub.t
--- gnu/usr.bin/perl/t/op/lexsub.t	13 Feb 2019 21:15:31 -0000	1.3
+++ gnu/usr.bin/perl/t/op/lexsub.t	21 May 2023 00:39:36 -0000
@@ -7,7 +7,7 @@ BEGIN {
     *bar::is = *is;
     *bar::like = *like;
 }
-plan 150;
+plan 151;
 
 # -------------------- our -------------------- #
 
@@ -960,3 +960,14 @@ like runperl(
 
 is join("-", qw(aa bb), do { my sub lleexx; 123 }, qw(cc dd)),
   "aa-bb-123-cc-dd", 'do { my sub...} in a list [perl #132442]';
+
+{
+    # this would crash because find_lexical_cv() couldn't handle an
+    # intermediate scope which didn't include the sub
+    no warnings 'experimental::builtin';
+    use builtin 'ceil';
+    sub nested {
+        ok(eval 'ceil(1.5)', "no assertion failure calling a lexical sub from nested eval");
+    }
+    nested();
+}
Index: gnu/usr.bin/perl/t/op/method.t
===================================================================
RCS file: /usr/obj/OP/cvs/src/gnu/usr.bin/perl/t/op/method.t,v
retrieving revision 1.14
diff -u -p -a -u -p -r1.14 method.t
--- gnu/usr.bin/perl/t/op/method.t	13 Feb 2019 21:15:31 -0000	1.14
+++ gnu/usr.bin/perl/t/op/method.t	21 May 2023 00:39:36 -0000
@@ -13,7 +13,7 @@ BEGIN {
 use strict;
 no warnings 'once';
 
-plan(tests => 162);
+plan(tests => 163);
 
 {
     # RT #126042 &{1==1} * &{1==1} would crash
@@ -713,6 +713,32 @@ SKIP: {
     sub RT123619::f { chop $_[0] }
     eval { 'RT123619'->f(); };
     like ($@, qr/Modification of a read-only value attempted/, 'RT #123619');
+}
+
+{
+    fresh_perl_is(<<'PROG', <<'EXPECT', {}, "don't negative cache NOUNIVERSAL lookups");
+use v5.36;
+
+my $foo;
+
+BEGIN {
+    $foo = bless {}, 'Foo';
+    $foo->isa('Foo') and say "->isa works!";
+ }
+
+# bump PL_sub_generation
+local *Foo::DESTROY = sub {};
+undef &Foo::DESTROY;
+local *Foo::DESTROY = sub {};
+
+$foo isa 'Foo' and say " and isa works!";
+$foo->isa('Foo') and say "->isa works!";
+
+PROG
+->isa works!
+ and isa works!
+->isa works!
+EXPECT
 }
 
 # RT#130496: assertion failure when looking for a method of undefined name
Index: gnu/usr.bin/perl/t/op/taint.t
===================================================================
RCS file: /usr/obj/OP/cvs/src/gnu/usr.bin/perl/t/op/taint.t,v
retrieving revision 1.27
diff -u -p -a -u -p -r1.27 taint.t
--- gnu/usr.bin/perl/t/op/taint.t	15 Feb 2023 01:36:36 -0000	1.27
+++ gnu/usr.bin/perl/t/op/taint.t	21 May 2023 00:39:36 -0000
@@ -25,7 +25,7 @@ if ($NoTaintSupport) {
     exit 0;
 }
 
-plan tests => 1054;
+plan tests => 1058;
 
 $| = 1;
 
@@ -2955,6 +2955,18 @@ is_tainted("$ovtaint", "overload preserv
     taint_sig3($TAINT);
 }
 
+{
+	# GH 19478: panic on s///gre with tainted utf8 strings
+	my $u = "\x{10469}";
+	my $r1 = ("foo$TAINT" =~ s/./"$u"/gre);
+	is($r1, "$u$u$u", 'tainted string with utf8 s/.//gre');
+	my $r2 = ("foo$TAINT" =~ s/.*/"${u}"/gre);
+	is($r2, "$u$u", 'tainted string with utf8 s/.*//gre');
+	my $r3 = ("foo$TAINT" =~ s/.+/"${u}"/gre);
+	is($r3, $u, 'tainted string with utf8 s/.+//gre');
+	my $r4 = ("$u$TAINT" =~ s/./""/gre);
+	is($r4, '', 'tainted utf8 string with s///gre');
+}
 
 # This may bomb out with the alarm signal so keep it last
 SKIP: {
Index: gnu/usr.bin/perl/t/op/write.t
===================================================================
RCS file: /usr/obj/OP/cvs/src/gnu/usr.bin/perl/t/op/write.t,v
retrieving revision 1.21
diff -u -p -a -u -p -r1.21 write.t
--- gnu/usr.bin/perl/t/op/write.t	15 Feb 2023 01:36:37 -0000	1.21
+++ gnu/usr.bin/perl/t/op/write.t	21 May 2023 00:39:36 -0000
@@ -33,6 +33,18 @@ sub cat_utf8 {
     $data;
 }
 
+# write a format to a plain file, then read it back in and compare
+
+sub is_format {
+    my ($glob, $want, $desc) = @_;
+    local $::Level = $::Level + 1;
+    my $file = 'Op_write.tmp';
+    open $glob, '>', $file or die "Can't create '$file': $!";
+    write $glob;
+    close $glob or die "Could not close '$file': $!";
+    is(cat($file), $want, $desc);
+}
+
 # write a format to a utf8 file, then read it back in and compare
 
 sub is_format_utf8 {
@@ -100,7 +112,8 @@ for my $tref ( @NumTests ){
 my $bas_tests = 21;
 
 # number of tests in section 3
-my $bug_tests = 66 + 3 * 3 * 5 * 2 * 3 + 2 + 66 + 6 + 2 + 3 + 96 + 11 + 14;
+my $bug_tests = 66 + 3 * 3 * 5 * 2 * 3 + 2 + 66 + 6 + 2 + 3 + 96 + 11 + 14
+                + 12;
 
 # number of tests in section 4
 my $hmb_tests = 37;
@@ -1360,6 +1373,47 @@ $v28f
 
 like_format_utf8(\*OUT28f, $qr_hash_m);
 
+my $v29a;
+format OUT29a =
+[^<<<]~~
+$v29a
+.
+
+$v29a = "-ABCD";
+is_format(\*OUT29a, "[-   ]\n[ABCD]\n");
+
+$v29a = "A-BCD";
+is_format(\*OUT29a, "[A-  ]\n[BCD ]\n");
+
+$v29a = "AB-CD";
+is_format(\*OUT29a, "[AB- ]\n[CD  ]\n");
+
+$v29a = "ABC-D";
+is_format(\*OUT29a, "[ABC-]\n[D   ]\n");
+
+$v29a = "ABCD-";
+is_format(\*OUT29a, "[ABCD]\n[-   ]\n");
+
+$v29a = "ABCDE-";
+is_format(\*OUT29a, "[ABCD]\n[E-  ]\n");
+
+$v29a = "-ABCD";
+is_format_utf8(\*OUT29a, "[-   ]\n[ABCD]\n");
+
+$v29a = "A-BCD";
+is_format_utf8(\*OUT29a, "[A-  ]\n[BCD ]\n");
+
+$v29a = "AB-CD";
+is_format_utf8(\*OUT29a, "[AB- ]\n[CD  ]\n");
+
+$v29a = "ABC-D";
+is_format_utf8(\*OUT29a, "[ABC-]\n[D   ]\n");
+
+$v29a = "ABCD-";
+is_format_utf8(\*OUT29a, "[ABCD]\n[-   ]\n");
+
+$v29a = "ABCDE-";
+is_format_utf8(\*OUT29a, "[ABCD]\n[E-  ]\n");
 
 
 {
Index: gnu/usr.bin/perl/t/re/pat_re_eval.t
===================================================================
RCS file: /usr/obj/OP/cvs/src/gnu/usr.bin/perl/t/re/pat_re_eval.t,v
retrieving revision 1.6
diff -u -p -a -u -p -r1.6 pat_re_eval.t
--- gnu/usr.bin/perl/t/re/pat_re_eval.t	15 Feb 2023 01:36:37 -0000	1.6
+++ gnu/usr.bin/perl/t/re/pat_re_eval.t	21 May 2023 00:39:36 -0000
@@ -24,7 +24,7 @@ BEGIN {
 
 our @global;
 
-plan tests => 506;  # Update this when adding/deleting tests.
+plan tests => 508;  # Update this when adding/deleting tests.
 
 run_tests() unless caller;
 
@@ -1331,6 +1331,21 @@ sub run_tests {
         eval { sub { " " }->() =~ /(?{ die })/ };
         pass("SvTEMP 2");
     }
+
+    # GH #19680 "panic: restartop in perl_run"
+    # The eval block embedded within the (?{}) - but with no more code
+    # following it - causes the next op after the OP_LEAVETRY to be NULL
+    # (not even an OP_LEAVE). This confused the exception-catching and
+    # rethrowing code: it was incorrectly rethrowing the exception rather
+    # than just stopping at that point.
+
+    ok("test" =~ m{^ (?{eval {die "boo!"}}) test $}x, "GH #19680");
+
+    # GH #19390 Segmentation fault with use re 'eval'
+    # Similar to  GH #19680 above, but exiting the eval via a syntax error
+    # rather than throwing an exception
+
+    ok("" =~ m{^ (?{eval q{$x=}})}x, "GH #19390");
 
 } # End of sub run_tests
 
Index: gnu/usr.bin/perl/vms/descrip_mms.template
===================================================================
RCS file: /usr/obj/OP/cvs/src/gnu/usr.bin/perl/vms/descrip_mms.template,v
retrieving revision 1.12
diff -u -p -a -u -p -r1.12 descrip_mms.template
--- gnu/usr.bin/perl/vms/descrip_mms.template	15 Feb 2023 01:36:37 -0000	1.12
+++ gnu/usr.bin/perl/vms/descrip_mms.template	21 May 2023 00:39:36 -0000
@@ -313,7 +313,7 @@ utils : $(utils1) $(utils2) $(utils3) $(
 extra.pods : miniperl
 	@ @extra_pods.com
 
-PERLDELTA_CURRENT = [.pod]perl5360delta.pod
+PERLDELTA_CURRENT = [.pod]perl5361delta.pod
 
 $(PERLDELTA_CURRENT) : [.pod]perldelta.pod
 	Copy/NoConfirm/Log $(MMS$SOURCE) $(PERLDELTA_CURRENT)
